<template>
	<q-page>
		<div class="q-pa-md">
			<div v-if="add" class="q-pa-sm">
				<div class="row">
					<div></div>
					<q-space />
					<div>
						<q-btn
							key="`btn_size_rd_sm`"
							class="bg-blue-6 text-white"
							size="sm"
							label="Assign task"
							@click="taskAdd(true)"
						/>
					</div>
				</div>
			</div>
			<q-table
				title="Todo list"
				:data="todos"
				:columns="columns"
				row-key="name"
			>
				<template v-slot:body="props">
					<q-tr :props="props">
						<q-td key="name" :props="props">
							{{ props.row.USERNAME }}
						</q-td>
						<q-td key="note" :props="props">
							{{ props.row.NOTES }}
						</q-td>
						<q-td key="status" :props="props">
							{{ props.row.STATUS }}
						</q-td>
						<q-td key="options" :props="props">
							<div class="q-pa-md">
								<q-btn-dropdown
									color="white"
									text-color="black"
									label="Options"
								>
									<q-list>
										<q-item
											v-if="edit"
											clickable
											v-close-popup
											@click="
												taskEdit({
													todoId: props.row.TODO_ID,
													todoNote: props.row.NOTES,
													todoStatus:
														props.row.STATUS,
													editForm: true,
												})
											"
										>
											<q-item-section>
												<q-item-label class="text-green"
													>Edit</q-item-label
												>
											</q-item-section>
										</q-item>
										<q-item
											v-if="del"
											clickable
											v-close-popup
											@click="
												taskDel({
													todoId: props.row.TODO_ID,
													todoName:
														props.row.USERNAME,
													delForm: true,
												})
											"
										>
											<q-item-section>
												<q-item-label class="text-red"
													>Delete</q-item-label
												>
											</q-item-section>
										</q-item>
									</q-list>
								</q-btn-dropdown>
							</div>
						</q-td>
					</q-tr>
				</template>
			</q-table>
		</div>

		<!-- IMPORTS -->
		<todo-edit @reload="getTodos" />
		<todo-del @reload="getTodos" />
		<todo-add />
		<add-task @reload="getTodos" />
	</q-page>
</template>

<script>
import { mapActions } from "vuex";
import { mapGetters } from "vuex";
// import { mapMutations } from "vuex";
export default {
	data() {
		return {
			add: true,
			edit: true,
			del: true,
			columns: [
				{
					name: "name",
					required: true,
					label: "Username",
					align: "left",
					field: (row) => row.name,
					format: (val) => `${val}`,
					sortable: true,
				},
				{
					name: "note",
					label: "Notes",
					align: "left",
					field: "note",
					sortable: true,
				},
				{
					name: "status",
					label: "Status",
					align: "left",
					field: "status",
					sortable: true,
				},
				{
					name: "options",
					label: "Options",
					align: "center",
					field: "options",
				},
			],
			todos: [],
		};
	},
	methods: {
		getTodos() {
			this.$axios
				.get(this.host + "/src/php/actions/todo.php")
				.then((response) => {
					this.todos = response.data;
				});
		},
		...mapActions({
			taskEdit: "showcase/taskEdit",
			taskDel: "showcase/taskDel",
			taskAdd: "showcase/taskAdd",
		}),
	},
	components: {
		"todo-edit": require("./todo-modals/TodoEdit.vue").default,
		"todo-del": require("./todo-modals/TodoDel.vue").default,
		"todo-add": require("./todo-modals/TodoAdd.vue").default,
		"add-task": require("./user-modals/UserAddTask.vue").default,
	},
	computed: {
		...mapGetters({
			tdAccess: "showcase/tdAccess",
			tdAdd: "showcase/tdAdd",
			tdEdit: "showcase/tdEdit",
			tdDelete: "showcase/tdDelete",
			userLevel: "showcase/userLevel",
		}),
	},
	created() {
		this.getTodos();
		if (this.userLevel == "staff") {
			this.add = JSON.parse(this.tdAdd);
			this.edit = JSON.parse(this.tdEdit);
			this.del = JSON.parse(this.tdDelete);
		}
	},
	watch: {
		// todos() {
		// 	this.getTodos();
		// },
	},
};
</script>
